Index: build/config.h.in
*** nvi-1.79/build/config.h.in	Fri Oct 11 09:17:23 1996
--- nvi-1.79-m17n/build/config.h.in	Wed Aug 20 14:47:14 1997
***************
*** 112,117 ****
--- 112,126 ----
  /* Define if your sprintf returns a pointer, not a length. */
  #undef SPRINTF_RET_CHARPNT
  
+ /* Define if you need multibyte support. */
+ #undef MULTIBYTE
+ 
+ /* Default value for multibyte support. */
+ #undef DEFAULT_ENCODING
+ 
+ /* Define if you need Canna support. */
+ #undef CANNA
+ 
  /* Define if you have the bsearch function.  */
  #undef HAVE_BSEARCH
  
***************
*** 172,179 ****
  /* Define if you have the unsetenv function.  */
  #undef HAVE_UNSETENV
  
- /* Define if you have the valloc function.  */
- #undef HAVE_VALLOC
- 
  /* Define if you have the vsnprintf function.  */
  #undef HAVE_VSNPRINTF
--- 181,188 ----
  /* Define if you have the unsetenv function.  */
  #undef HAVE_UNSETENV
  
  /* Define if you have the vsnprintf function.  */
  #undef HAVE_VSNPRINTF
+ 
+ /* Define if you have the <unistd.h> header file.  */
+ #undef HAVE_UNISTD_H
Index: build/configure.in
Prereq: 	8.134 
*** nvi-1.79/build/configure.in	Wed Oct 23 22:52:59 1996
--- nvi-1.79-m17n/build/configure.in	Wed Apr  2 13:31:31 1997
***************
*** 22,27 ****
--- 22,42 ----
  fi
  AC_MSG_RESULT($vi_cv_debug)
  
+ dnl If the user wants multibyte support.
+ AC_MSG_CHECKING(if --enable-multibyte option specified)
+ AC_ARG_ENABLE(multibyte,
+ 	[  --enable-multibyte[=ARG] Build a multibyte version.],
+ 	[vi_cv_multibyte="yes"; vi_cv_defencoding=$enableval], [vi_cv_multibyte="no"])
+ if test "$vi_cv_multibyte" = yes; then
+ 	AC_DEFINE(MULTIBYTE)
+ 	if test "$vi_cv_defencoding" = yes; then
+ 		AC_DEFINE_UNQUOTED(DEFAULT_ENCODING, "none")
+ 	else
+ 		AC_DEFINE_UNQUOTED(DEFAULT_ENCODING, "${vi_cv_defencoding}")
+ 	fi
+ fi
+ AC_MSG_RESULT($vi_cv_multibyte)
+ 
  dnl This is where we handle stuff that autoconf can't handle.
  dnl XXX
  dnl Don't override anything if it's already set from the environment.
***************
*** 194,199 ****
--- 209,279 ----
  	fi
  fi
  
+ dnl If the user wants canna support.
+ AC_MSG_CHECKING(if --enable-canna option specified)
+ AC_ARG_ENABLE(canna,
+ 	[  --enable-canna[=DIR] Build a canna version.],
+ 	[vi_cv_canna="yes"; vi_cannapath=$enableval], [vi_cv_canna="no"])
+ AC_MSG_RESULT($vi_cv_canna)
+ if test "$vi_cv_canna" = "yes"; then
+ 	if test "$vi_cv_multibyte" = "no"; then
+ 		echo "Fatal error: --enable-canna needs --enable-multibyte."
+ 		exit 1
+ 	fi
+ 
+ dnl Some operating system include canna libraries by default.
+ dnl Use that pathname by default.
+ dnl for freebsd2.*, order DOES matter.  don't bother.
+ 	if test "$vi_cannapath" = "yes"; then
+ 		case "$host_os" in
+ 		bsdi2.1)
+ 			vi_cannapath="/usr/contrib/canna";;
+ 		freebsd2.2*|freebsd3*)
+ 			vi_cannapath="/usr/local";;
+ 		freebsd2*)
+ 			vi_cannapath="/usr/local/canna";;
+ 		*)
+ 			vi_cannapath="/usr/local/canna";;
+ 		esac
+ 	fi
+ 
+ 	if test "$vi_cannapath" != "yes"; then
+ 		CFLAGS="-I$vi_cannapath/include $CFLAGS"
+ 		LDFLAGS="-L$vi_cannapath/lib $LDFLAGS"
+ 	fi
+ 
+ dnl we use AC_TRY_COMPILE not AC_CHECK_HEADER, to avoid unnecessery
+ dnl use of CPPFLAGS. (why?)
+ 	AC_MSG_CHECKING(for canna/jrkanji.h)
+ 	AC_CACHE_VAL(vi_cv_cannahdrcheck, [dnl
+ 	AC_TRY_COMPILE([#include <canna/jrkanji.h>], jrKanjiStatus ks;,
+ 		[vi_cv_cannahdrcheck="yes"], [vi_cv_cannahdrcheck="no"])])
+ 	AC_MSG_RESULT($vi_cv_cannahdrcheck)
+ 	if test "$vi_cv_cannahdrcheck" = "no"; then
+ 		echo -n "Fatal error: no canna header in suggested path"
+ 		if test "$vi_cannapath" != "yes"; then
+ 			echo ", $vi_cannapath/include."
+ 		else
+ 			echo "."
+ 		fi
+ 		exit 1
+ 	fi
+ 
+ 	AC_CHECK_LIB(canna, jrKanjiControl,
+ 		[vi_cv_cannalibcheck="yes"], [vi_cv_cannalibcheck="no"])
+ 	if test "$vi_cv_cannalibcheck" = "no"; then
+ 		echo "Fatal error: no canna library in suggested path"
+ 		if test "$vi_cannapath" != "yes"; then
+ 			echo ", $vi_cannapath/lib."
+ 		else
+ 			echo "."
+ 		fi
+ 		exit 1
+ 	fi
+ 	LIBS="-lcanna $LIBS"
+ 	AC_DEFINE(CANNA)
+ fi
+ 
  dnl If the user wants a Perl interpreter in nvi, load it.
  AC_SUBST(shrpenv)
  AC_SUBST(vi_cv_perllib)
***************
*** 722,725 ****
  fi
  
  AC_OUTPUT(Makefile port.h:port.h.in
!     pathnames.h:pathnames.h.in recover:recover.in)
--- 802,806 ----
  fi
  
  AC_OUTPUT(Makefile port.h:port.h.in
!     pathnames.h:pathnames.h.in recover:recover.in
!     regular:regular.in qregular:qregular.in)
Index: build/distrib
Prereq: 	8.11 
*** nvi-1.79/build/distrib	Wed Oct 23 22:40:49 1996
--- nvi-1.79-m17n/build/distrib	Wed Apr  2 13:32:02 1997
***************
*** 2,9 ****
  # @(#)distrib	8.11 (Berkeley) 10/23/96
  
  # Clean
! #make -f Makefile.in clean
! #rm -f configure config.h.in
  
  # Build autoconf structure.
  echo "Running autoheader"
--- 2,9 ----
  # @(#)distrib	8.11 (Berkeley) 10/23/96
  
  # Clean
! make -f Makefile.in clean
! rm -f configure config.h.in
  
  # Build autoconf structure.
  echo "Running autoheader"
***************
*** 74,79 ****
--- 74,85 ----
  echo "Building $f"
  rm -f $f
  sed -n "s/^ \* PUBLIC: \(.*\)/\1/p" ../vi/*.c > $f
+ chmod 444 $f
+ 
+ f=../include/multibyte_def.h
+ echo "Building $f"
+ rm -f $f
+ awk -f ../common/multibyte.awk ../common/multibyte.c > $f
  chmod 444 $f
  
  # Build tags files.
Index: build/qregular.in
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/build/qregular.in	Fri Mar 28 23:41:35 1997
***************
*** 0 ****
--- 1,67 ----
+ #! @vi_cv_path_perl@
+ 
+ #
+ # Regularize multibyte text to some extent.
+ # Quick version; it recognizes G0/G1 designation only.
+ #
+ # Absolutely no warranty.  Freely redistributable.
+ # copyright(c) 1997 by Jun-ichiro itojun Itoh.  All rights reserved.
+ #
+ # $Id: qregular.in,v 1.3 1997/03/28 14:41:33 itojun Exp $
+ #
+ 
+ $variation94 = '#$@[\]^`{|}~';
+ 
+ while (<STDIN>) {
+ 	chop;
+ 	$line = $_;
+ 	$output = '';
+ 
+ 	while (length($line)) {
+ 		$pos = index($line, "\033");
+ 		if ($pos == -1) {
+ 			$output = $line;
+ 			$line = '';
+ 			next;
+ 		}
+ 
+ 		$output .= substr($line, 0, $pos);
+ 		$line = substr($line, $pos);
+ 
+ 		if ($line =~ /^\033\(([\@ABCGHJKLRTYZ`fghinuwxz])([\041-\176]*)(.*)$/) {
+ 			$code = $1;
+ 			$tmp = $2;
+ 			$line = $3;
+ 
+ 			$tmp = "\033(B" . $tmp . "\033(B";
+ 			$tmp =~ s/([#$\@\[\\\]^{|}~]+)/\033($code$1\033(B/g;
+ 			$tmp =~ s/\033\([0-\177](\033\([0-\177])/$1/g;
+ 
+ 			$output .= $tmp;
+ 		} elsif ($line =~ /^\033\)([\@ABCGHJKLRTYZ`fghinuwxz])([\241-\376]*)(.*)$/) {
+ 			$code = $1;
+ 			$tmp = $2;
+ 			$line = $3;
+ 
+ 			$tmp = "\033)B" . $tmp . "\033)B";
+ 			$tmp =~ s/([#$\@\[\\\]^{|}~]+)/\033)$code$1\033)B/g;
+ 			$tmp =~ s/\033\)[0-\177](\033\)[0-\177])/$1/g;
+ 
+ 			$output .= $tmp;
+ 		} else {
+ 			$pos = index($line, "\033", 1);
+ 			if ($pos == -1) {
+ 				$output .= $line;
+ 				$line = '';
+ 			} else {
+ 				$output .= substr($line, 0, $pos);
+ 				$line = substr($line, $pos);
+ 			}
+ 		}
+ 	}
+ 
+ 	$output =~ s/\033\([0-\177](\033\([0-\177])/$1/g;
+ 	print $output . "\n";
+ }
+ 
+ exit 0;
Index: build/regular.in
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/build/regular.in	Wed Aug 20 16:29:06 1997
***************
*** 0 ****
--- 1,408 ----
+ #! @vi_cv_path_perl@
+ 
+ #
+ # Regularize multibyte text to some extent.
+ #
+ # Absolutely no warranty.  Freely redistributable.
+ # copyright(c) 1997 by Jun-ichiro itojun Itoh.  All rights reserved.
+ #
+ # $Id: regular.in,v 1.5 1997/03/28 14:41:33 itojun Exp $
+ #
+ 
+ # initial designation
+ @ig0 = @ig = ('B94', '', '', '');
+ $igl = 0;
+ $igr = 1;
+ $igl1 = -1;
+ $igr1 = -1;
+ 
+ @og = ('B94', '', '', '');
+ $ogl = 0;
+ $ogr = 1;
+ $ogl1 = -1;
+ $ogr1 = -1;
+ 
+ $variation94 = '#$@[\]^`{|}~';
+ 
+ # configurations
+ $eolreset = 1;
+ $oldstyle = 1;
+ $output7 = 1;
+ foreach $i (grep(/^-/, @ARGV)) {
+ 	if ($i eq '-ctext') {
+ 		$oldstyle = 0;
+ 		$output7 = 1;
+ 	} elsif ($i eq '-kr') {
+ 		$eolreset = 0;
+ 	} elsif ($i eq '-7') {
+ 		$output7 = 1;
+ 	} elsif ($i eq '-8') {
+ 		$output7 = 0;
+ 	} else {
+ 		print STDERR "regular: unknown option $i.\n";
+ 		exit 1;
+ 	}
+ }
+ 
+ if (scalar(grep(/^[^-]/, @ARGV))) {
+ 	print STDERR "regular: I take no argument.\n";
+ 	exit 1;
+ }
+ 
+ while (<STDIN>) {
+ 	$line = $_;
+ 
+ 	while (length($line)) {
+ 		($chcode1, $chcode2) = unpack('CC', $line);
+ 
+ 		# escape sequence
+ 		if ($consume = &parsedesig($line)) {
+ 			$line = substr($line, $consume);
+ 			next;
+ 		}
+ 
+ 		# control code
+ 		if ($chcode1 & 0x7f < 0x20) {
+ 			$mask = &selthischarset(0, 'B94');
+ 			print pack('C', ($chcode1 & 0x7f) | $mask);
+ 			$line = substr($line, 1);
+ 			next;
+ 		}
+ 
+ 		# normal chars
+ 		if (&validch1(0, $chcode1)) {
+ 			if (&variation1(0, $chcode1)) {
+ 				$mask = &selthischarset(0, 'B94');
+ 			} else {
+ 				$mask = &selcharset(0);
+ 			}
+ 			print pack('C', ($chcode1 & 0x7f) | $mask);
+ 			$line = substr($line, 1);
+ 		} elsif (&validch1(1, $chcode1)) {
+ 			if (&variation1(1, $chcode1)) {
+ 				$mask = &selthischarset(1, 'B94');
+ 			} else {
+ 				$mask = &selcharset(1);
+ 			}
+ 			print pack('C', ($chcode1 & 0x7f) | $mask);
+ 			$line = substr($line, 1);
+ 		} elsif (&validch2(0, $chcode1, $chcode2)) {
+ 			$mask = &selcharset(0);
+ 			print pack('C', ($chcode1 & 0x7f) | $mask);
+ 			print pack('C', ($chcode2 & 0x7f) | $mask);
+ 			$line = substr($line, 2);
+ 		} elsif (&validch2(1, $chcode1, $chcode2)) {
+ 			$mask = &selcharset(1);
+ 			print pack('C', ($chcode1 & 0x7f) | $mask);
+ 			print pack('C', ($chcode2 & 0x7f) | $mask);
+ 			$line = substr($line, 2);
+ 		} else {
+ 			# unknown char.  emit as is.
+ 			if ($chcode1 & 0x80) {
+ 				&selthischarset(1, 'B94');
+ 			} else {
+ 				&selthischarset(0, 'B94');
+ 			}
+ 			print substr($line, 0, 1);
+ 			$line = substr($line, 1);
+ 		}
+ 
+ 		$igl1 = $igr1 = -1;
+ 		$ogl1 = $ogr1 = -1;
+ 	}
+ 	&selthischarset(0, 'B94');
+ 	&selthischarset(1, 'B94') if ($og[1] ne '');
+ 	&selthischarset(2, 'B94') if ($og[2] ne '');
+ 	&selthischarset(3, 'B94') if ($og[3] ne '');
+ 	if ($eolreset) {
+ 		@ig = @ig0;
+ 	}
+ 	$igl = 0;
+ 	$igr = 1;
+ 	$igl1 = -1;
+ 	$igr1 = -1;
+ }
+ 
+ exit 0;
+ 
+ #
+ # check if the character is valid as 1-byte char (94 or 96) in the charset
+ # designated in the input stream.
+ #
+ sub validch1 {
+ 	local($leftright, $code1) = @_;
+ 	local($curcharset, $off);
+ 
+ 	if (($igl1, $igr1)[$leftright] == -1) {
+ 		$curcharset = $ig[($igl, $igr)[$idx]];
+ 	} else {
+ 		$curcharset = $ig[($igl1, $igr1)[$idx]];
+ 	}
+ 	$off = (0x00, 0x80)[$leftright];
+ 
+ 	if ($curcharset =~ /94$/) {
+ 		if (0x21 + $off <= $code1 && $code1 <= 0x7e + $off) {
+ 			return 1;
+ 		} else {
+ 			return 0;
+ 		}
+ 	} elsif ($curcharset =~ /96$/) {
+ 		if (0x20 + $off <= $code1 && $code1 <= 0x7f + $off) {
+ 			return 1;
+ 		} else {
+ 			return 0;
+ 		}
+ 	} else {
+ 		return 0;
+ 	}
+ }
+ 
+ #
+ # check if the character is valid as 2-byte char (94x94 or 96x96)
+ # in the charset designated in the input stream.
+ #
+ sub validch2 {
+ 	local($leftright, $code1, $code2) = @_;
+ 	local($curcharset, $off);
+ 
+ 	if (($igl1, $igr1)[$leftright] == -1) {
+ 		$curcharset = $ig[($igl, $igr)[$idx]];
+ 	} else {
+ 		$curcharset = $ig[($igl1, $igr1)[$idx]];
+ 	}
+ 	$off = (0x00, 0x80)[$leftright];
+ 
+ 	if ($curcharset =~ /94x$/) {
+ 		if (0x21 + $off <= $code1 && $code1 <= 0x7e + $off
+ 		 && 0x21 + $off <= $code2 && $code2 <= 0x7e + $off) {
+ 			return 1;
+ 		} else {
+ 			return 0;
+ 		}
+ 	} elsif ($curcharset =~ /96x$/) {
+ 		if (0x20 + $off <= $code1 && $code1 <= 0x7f + $off
+ 		 && 0x20 + $off <= $code2 && $code2 <= 0x7f + $off) {
+ 			return 1;
+ 		} else {
+ 			return 0;
+ 		}
+ 	} else {
+ 		return 0;
+ 	}
+ }
+ 
+ #
+ # Parse the designation in input stream.
+ #
+ sub parsedesig {
+ 	local($line) = @_;
+ 	local($idx);
+ 	local($version, $verslen);
+ 
+ 	if (index("\033\216\217\017\016", substr($line, 0, 1)) == -1) {
+ 		return 0;
+ 	}
+ 
+ 	if ($line =~ /^\033\&([0-\177])/) {
+ 		$version = $1;
+ 		$verslen = length($&);
+ 		$line = substr($line, $verslen);
+ 	} else {
+ 		$version = '';
+ 		$verslen = 0;
+ 	}
+ 
+ 	if ($line =~ /^\033\$([\@AB])/) {
+ 		$ig[0] = $1 . $version . '94x';
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /^\033([\(\)*+])([0-\177])/) {
+ 		$idx = index('()*+', $1);
+ 		$ig[$idx] = $2 . $version . '94';
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /^\033([,-.\/])([0-\177])/) {
+ 		$idx = index(',-./', $1);
+ 		$ig[$idx] = $2 . $version . '96';
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /^\033\$([\(\)*+])([0-\177])/) {
+ 		$idx = index('()*+', $1);
+ 		$ig[$idx] = $2 . $version . '94x';
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /^\033\$([,-.\/])([0-\177])/) {
+ 		$idx = index(',-./', $1);
+ 		$ig[$idx] = $2 . $version . '96x';
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\017/) {	# LS0
+ 		$igl = 0;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\016/) {	# LS1
+ 		$igl = 1;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033n/) {	# LS2
+ 		$igl = 2;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033o/) {	# LS3
+ 		$igl = 3;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033~/) {	# LS1R
+ 		$igr = 1;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033}/) {	# LS2R
+ 		$igr = 2;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033\|/) {	# LS3R
+ 		$igr = 3;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033N/) {	# SS2
+ 		$igl1 = 2;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\033O/) {	# SS3
+ 		$igl1 = 3;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\216/) {	# SS2R
+ 		$igr1 = 2;
+ 		return length($&) + $verslen;
+ 	} elsif ($line =~ /\217/) {	# SS3R
+ 		$igr1 = 3;
+ 		return length($&) + $verslen;
+ 	}
+ 
+ 	return 0;
+ }
+ 
+ #
+ # Emit designation to output stream, based on the designation in input stream.
+ #
+ sub selcharset {
+ 	local($idx) = @_;
+ 	local($curcharset, $mask);
+ 
+ 	if (($igl1, $igr1)[$idx] == -1) {
+ 		$curcharset = $ig[($igl, $igr)[$idx]];
+ 	} else {
+ 		$curcharset = $ig[($igl1, $igr1)[$idx]];
+ 	}
+ 
+ 	if ($curcharset eq $og[$ogl]) {
+ 		return 0x00;
+ 	} elsif ($curcharset eq $og[$ogr]) {
+ 		return 0x80;
+ 	}
+ 
+ 	if ($oldstyle && $curcharset =~ /^([\@AB])94x$/) {
+ 		print "\033\$" . $1;
+ 		$og[$ogl] = $curcharset;
+ 	} elsif ($oldstyle && $curcharset eq 'B@94x') {
+ 		print "\033&\@\033\$B";
+ 		$og[$ogl] = $curcharset;
+ 	} elsif ($curcharset =~ /^(.)94$/) {
+ 		print "\033(" . $1;
+ 		$og[$ogl] = $curcharset;
+ 	} elsif ($curcharset =~ /^(.)96$/) {
+ 		if ($output7) {
+ 			print "\033," . $1;
+ 			$og[$ogl] = $curcharset;
+ 		} else {
+ 			print "\033-" . $1;
+ 			$mask = 0x80;
+ 			$og[$ogr] = $curcharset;
+ 		}
+ 	} elsif ($curcharset =~ /^(.)94x$/) {
+ 		print "\033\$(" . $1;
+ 		$og[$ogl] = $curcharset;
+ 	} elsif ($curcharset =~ /^(.)(.)94x$/) {
+ 		print "\033&" . $2 . "\033\$(" . $1;
+ 		$og[$ogl] = $curcharset;
+ 	} elsif ($curcharset =~ /^(.)96x$/) {
+ 		if ($output7) {
+ 			print "\033\$," . $1;
+ 			$og[$ogl] = $curcharset;
+ 		} else {
+ 			print "\033\$-" . $1;
+ 			$mask = 0x80;
+ 			$og[$ogr] = $curcharset;
+ 		}
+ 	}
+ 
+ 	return $mask;
+ }
+ 
+ #
+ # Emit designation to output stream, based on the programmer's decision.
+ #
+ sub selthischarset {
+ 	local($leftright, $charset) = @_;
+ 	local($curcharset, $mask, $tmp);
+ 
+ 	if (($ogl1, $ogr1)[$leftright] == -1) {
+ 		$curcharset = $og[($ogl, $ogr)[$leftright]];
+ 	} else {
+ 		$curcharset = $og[($ogl1, $ogr1)[$leftright]];
+ 	}
+ 	$mask = (0x00, 0x80)[$leftright];
+ 
+ 	$tmp = ($ogl, $ogr)[$leftright];
+ 	$mask = (0x00, 0x80)[$leftright];
+ 	if ($oldstyle && $leftright == 0 && $charset =~ /^([\@AB])94x$/) {
+ 		if ($charset ne $curcharset) {
+ 			print "\033\$" . $1;
+ 			$og[$ogl] = $charset;
+ 		}
+ 	} elsif ($oldstyle && $leftright == 0 && $charset eq 'B@94x') {
+ 		if ($charset ne $curcharset) {
+ 			print "\033&\@\033\$" . $1;
+ 			$og[$ogl] = $charset;
+ 		}
+ 	} elsif ($charset =~ /^(.)94$/) {
+ 		if ($charset ne $curcharset) {
+ 			print "\033" . ('(', ')')[$leftright] . $1;
+ 			$og[$tmp] = $charset;
+ 		}
+ 	} elsif ($charset =~ /^(.)96$/) {
+ 		if ($charset ne $curcharset) {
+ 			print "\033" . (',', '-')[$leftright] . $1;
+ 			$og[$tmp] = $charset;
+ 		}
+ 	} elsif ($charset =~ /^(.)94x$/) {
+ 		if ($charset ne $curcharset) {
+ 			print "\033\$" . ('(', ')')[$leftright] . $1;
+ 			$og[$tmp] = $charset;
+ 		}
+ 	} elsif ($charset =~ /^(.)(.)94x$/) {
+ 		if ($charset ne $curcharset) {
+ 			print "\033&" . $2;
+ 			print "\033\$" . ('(', ')')[$leftright] . $1;
+ 			$og[$tmp] = $charset;
+ 		}
+ 	} elsif ($charset =~ /^(.)96x$/) {
+ 		if ($charset ne $curcharset) {
+ 			print "\033\$" . (',', '-')[$leftright] . $1;
+ 			$og[$tmp] = $charset;
+ 		}
+ 	}
+ 
+ 	return $mask;
+ }
+ 
+ #
+ # Returns 1 if the character would better be emitted in ASCII charset.
+ #
+ sub variation1 {
+ 	local($leftright, $code) = @_;
+ 	local($curcharset);
+ 
+ 	if (($igl1, $igr1)[$leftright] == -1) {
+ 		$curcharset = $ig[($igl, $igr)[$leftright]];
+ 	} else {
+ 		$curcharset = $ig[($igl1, $igr1)[$leftright]];
+ 	}
+ 
+ 	if ($curcharset =~ /^[\@ABCGHJKLRTYZ`fghinuwxz]94$/) {
+ 		if (index($variation94, pack('C', $code & 0x7f)) == -1) {
+ 			return 1;
+ 		} else {
+ 			return 0;
+ 		}
+ 	} else {
+ 		return 0;
+ 	}
+ }
